/* curses_ui.c generated by valac 0.10.1, the Vala compiler
 * generated from curses_ui.vala, do not modify */

/*

this is a part of sap
copyright 2008 jezra lickter http://www.jezra.net

sap is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

sap is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sap.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <stdio.h>
#include <curses.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_WIN (win_get_type ())
#define WIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WIN, Win))
#define WIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WIN, WinClass))
#define IS_WIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WIN))
#define IS_WIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WIN))
#define WIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WIN, WinClass))

typedef struct _Win Win;
typedef struct _WinClass WinClass;
typedef struct _WinPrivate WinPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Win {
	GObject parent_instance;
	WinPrivate * priv;
	GThread* thread;
	gboolean looping;
};

struct _WinClass {
	GObjectClass parent_class;
};

struct _WinPrivate {
	gint c;
	gint forward_tick;
	gint backward_tick;
	gint forward_speed;
	gint backward_speed;
};


static gpointer win_parent_class = NULL;

GType win_get_type (void) G_GNUC_CONST;
#define WIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WIN, WinPrivate))
enum  {
	WIN_DUMMY_PROPERTY
};
Win* win_new (void);
Win* win_construct (GType object_type);
void win_reset_speed (Win* self);
void win_quit_ui_thread (Win* self);
void win_cleanup (Win* self);
void win_quit_app (Win* self);
gboolean win_run (Win* self);
void* win_ui_thread (Win* self);
static void* _win_ui_thread_gthread_func (gpointer self);
void win_do_seek_backward (Win* self);
void win_do_seek_forward (Win* self);
void win_clear_screen (Win* self);
void win_set_artist (Win* self, const char* artist);
void win_write_line (Win* self, gint line, const char* str);
void win_set_title (Win* self, const char* title);
void win_set_album (Win* self, const char* album);
void win_set_status (Win* self, const char* str);
void win_display_info (Win* self, const char* str);
void win_set_file_path (Win* self, const char* path);
void win_set_played_percent (Win* self, gint per);
static GObject * win_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void win_finalize (GObject* obj);



Win* win_construct (GType object_type) {
	Win * self = NULL;
	self = (Win*) g_object_new (object_type, NULL);
	return self;
}


Win* win_new (void) {
	return win_construct (TYPE_WIN);
}


void win_reset_speed (Win* self) {
	g_return_if_fail (self != NULL);
	self->priv->forward_speed = 5;
	self->priv->backward_speed = 5;
	self->priv->forward_tick = 0;
	self->priv->backward_tick = 0;
}


void win_quit_ui_thread (Win* self) {
	g_return_if_fail (self != NULL);
	self->looping = FALSE;
	win_cleanup (self);
}


void win_quit_app (Win* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "quit");
}


static void* _win_ui_thread_gthread_func (gpointer self) {
	void* result;
	result = win_ui_thread (self);
	return result;
}


gboolean win_run (Win* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GThread* _tmp0_;
		_tmp0_ = g_thread_create (_win_ui_thread_gthread_func, self, FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch0_g_thread_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		self->thread = _tmp0_;
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError * ex;
		ex = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stderr, "Failed to create the UI thread");
			result = FALSE;
			_g_error_free0 (ex);
			return result;
		}
	}
	__finally0:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


void* win_ui_thread (Win* self) {
	void* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	while (TRUE) {
		if (!self->looping) {
			break;
		}
		self->priv->c = getch ();
		switch (self->priv->c) {
			case 'r':
			{
				g_signal_emit_by_name (self, "toggle-random");
				break;
			}
			case 'c':
			{
				g_signal_emit_by_name (self, "toggle-continuous");
				break;
			}
			case 'q':
			{
				win_quit_app (self);
				break;
			}
			case KEY_LEFT:
			case 'h':
			{
				win_do_seek_backward (self);
				break;
			}
			case KEY_RIGHT:
			case 'l':
			{
				win_do_seek_forward (self);
				break;
			}
			case KEY_UP:
			case 'k':
			{
				g_signal_emit_by_name (self, "change-volume-up");
				break;
			}
			case KEY_DOWN:
			case 'j':
			{
				g_signal_emit_by_name (self, "change-volume-down");
				break;
			}
			case ' ':
			{
				g_signal_emit_by_name (self, "pause");
				break;
			}
			case 'b':
			case KEY_BTAB:
			{
				g_signal_emit_by_name (self, "previous-track");
				break;
			}
			case 'n':
			case 9:
			{
				g_signal_emit_by_name (self, "next-track");
				break;
			}
			default:
			{
				win_reset_speed (self);
				break;
			}
		}
	}
	result = NULL;
	return result;
}


void win_cleanup (Win* self) {
	g_return_if_fail (self != NULL);
	move (0, 0);
	deleteln ();
	refresh ();
	nocbreak ();
	echo ();
	endwin ();
}


void win_clear_screen (Win* self) {
	g_return_if_fail (self != NULL);
	move (4, 0);
	clrtobot ();
}


void win_set_artist (Win* self, const char* artist) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (artist != NULL);
	win_write_line (self, LINES - 4, _tmp0_ = g_strdup_printf ("Artist: %s", artist));
	_g_free0 (_tmp0_);
}


void win_set_title (Win* self, const char* title) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	win_write_line (self, LINES - 5, _tmp0_ = g_strdup_printf ("Title: %s", title));
	_g_free0 (_tmp0_);
}


void win_set_album (Win* self, const char* album) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (album != NULL);
	win_write_line (self, LINES - 3, _tmp0_ = g_strdup_printf ("Album: %s", album));
	_g_free0 (_tmp0_);
}


void win_set_status (Win* self, const char* str) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	win_write_line (self, LINES - 2, _tmp0_ = g_strdup_printf ("%s", str));
	_g_free0 (_tmp0_);
}


void win_write_line (Win* self, gint line, const char* str) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	move (line, 0);
	clrtoeol ();
	addstr (str);
	refresh ();
}


void win_display_info (Win* self, const char* str) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
}


void win_set_file_path (Win* self, const char* path) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	win_write_line (self, LINES - 6, path);
}


void win_set_played_percent (Win* self, gint per) {
	gint char_num;
	gint pad_num;
	g_return_if_fail (self != NULL);
	char_num = ((gint) ((COLS * per) / 100)) - 1;
	pad_num = (COLS - char_num) - 3;
	move (LINES - 1, 0);
	clrtoeol ();
	addch ((gulong) '[');
	{
		gint i;
		i = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					i++;
				}
				_tmp0_ = FALSE;
				if (!(i < char_num)) {
					break;
				}
				addch ((gulong) '=');
			}
		}
	}
	addch ((gulong) '|');
	{
		gint i;
		i = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					i++;
				}
				_tmp1_ = FALSE;
				if (!(i < pad_num)) {
					break;
				}
				addch ((gulong) '-');
			}
		}
	}
	addch ((gulong) ']');
}


void win_do_seek_forward (Win* self) {
	g_return_if_fail (self != NULL);
	self->priv->backward_speed = 1;
	self->priv->forward_tick = self->priv->forward_tick + 1;
	if (self->priv->forward_tick == 50) {
		self->priv->forward_speed = self->priv->forward_speed + 5;
		self->priv->forward_tick = 0;
	}
	g_signal_emit_by_name (self, "seek-forward", self->priv->forward_speed);
}


void win_do_seek_backward (Win* self) {
	g_return_if_fail (self != NULL);
	self->priv->forward_speed = 1;
	self->priv->backward_tick = self->priv->backward_tick + 1;
	if (self->priv->backward_tick == 50) {
		self->priv->backward_speed = self->priv->backward_speed + 5;
		self->priv->backward_tick = 0;
	}
	g_signal_emit_by_name (self, "seek-back", self->priv->backward_speed);
}


static GObject * win_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Win * self;
	parent_class = G_OBJECT_CLASS (win_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = WIN (obj);
	{
		self->looping = TRUE;
		initscr ();
		curs_set (0);
		noecho ();
		halfdelay (10);
		keypad (stdscr, TRUE);
		win_reset_speed (self);
	}
	return obj;
}


static void win_class_init (WinClass * klass) {
	win_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (WinPrivate));
	G_OBJECT_CLASS (klass)->constructor = win_constructor;
	G_OBJECT_CLASS (klass)->finalize = win_finalize;
	g_signal_new ("seek_forward", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_signal_new ("seek_back", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	g_signal_new ("pause", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("quit", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("change_volume_up", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("change_volume_down", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("next_track", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("previous_track", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("toggle_random", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("toggle_continuous", TYPE_WIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void win_instance_init (Win * self) {
	self->priv = WIN_GET_PRIVATE (self);
}


static void win_finalize (GObject* obj) {
	Win * self;
	self = WIN (obj);
	G_OBJECT_CLASS (win_parent_class)->finalize (obj);
}


GType win_get_type (void) {
	static volatile gsize win_type_id__volatile = 0;
	if (g_once_init_enter (&win_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WinClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) win_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Win), 0, (GInstanceInitFunc) win_instance_init, NULL };
		GType win_type_id;
		win_type_id = g_type_register_static (G_TYPE_OBJECT, "Win", &g_define_type_info, 0);
		g_once_init_leave (&win_type_id__volatile, win_type_id);
	}
	return win_type_id__volatile;
}




