/* main_controller.c generated by valac 0.10.1, the Vala compiler
 * generated from main_controller.vala, do not modify */

/*

this is a part of sap
copyright 2008 jezra lickter http://www.jezra.net

sap is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

sap is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sap.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gst/gst.h>
#include <config.h>
#include <stdio.h>


#define TYPE_ERRORS (errors_get_type ())

#define TYPE_CONTROLLER (controller_get_type ())
#define CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTROLLER, Controller))
#define CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTROLLER, ControllerClass))
#define IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTROLLER))
#define IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTROLLER))
#define CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTROLLER, ControllerClass))

typedef struct _Controller Controller;
typedef struct _ControllerClass ControllerClass;
typedef struct _ControllerPrivate ControllerPrivate;

#define TYPE_URI_PLAYER (uri_player_get_type ())
#define URI_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_URI_PLAYER, UriPlayer))
#define URI_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_URI_PLAYER, UriPlayerClass))
#define IS_URI_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_URI_PLAYER))
#define IS_URI_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_URI_PLAYER))
#define URI_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_URI_PLAYER, UriPlayerClass))

typedef struct _UriPlayer UriPlayer;
typedef struct _UriPlayerClass UriPlayerClass;

#define TYPE_WIN (win_get_type ())
#define WIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WIN, Win))
#define WIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WIN, WinClass))
#define IS_WIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WIN))
#define IS_WIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WIN))
#define WIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WIN, WinClass))

typedef struct _Win Win;
typedef struct _WinClass WinClass;

#define TYPE_TRACK_LIST (track_list_get_type ())
#define TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRACK_LIST, TrackList))
#define TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRACK_LIST, TrackListClass))
#define IS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRACK_LIST))
#define IS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRACK_LIST))
#define TRACK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRACK_LIST, TrackListClass))

typedef struct _TrackList TrackList;
typedef struct _TrackListClass TrackListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_option_group_free0(var) ((var == NULL) ? NULL : (var = (g_option_group_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	ERRORS_NO_INPUT_FILE,
	ERRORS_FILE_NOT_FOUND,
	ERRORS_NO_TRACKS_FOUND
} Errors;

struct _Controller {
	GObject parent_instance;
	ControllerPrivate * priv;
};

struct _ControllerClass {
	GObjectClass parent_class;
};

struct _ControllerPrivate {
	UriPlayer* myPlayer;
	Win* myWin;
	TrackList* trackList;
	char* version;
	char* summary;
	char* description;
	char* status_text;
	GMainLoop* loop;
	GOptionContext* ctx;
	char* ap_play_time;
	char* ap_total_time;
	double ap_volume;
	gint ap_percent_played;
	char* ap_state;
};


extern char** controller__uri;
char** controller__uri = NULL;
extern gboolean controller__list;
gboolean controller__list = FALSE;
extern gboolean controller__random;
gboolean controller__random = FALSE;
extern gboolean controller__continuous;
gboolean controller__continuous = FALSE;
extern double controller__volume;
double controller__volume = (double) 70;
extern gboolean controller__version;
gboolean controller__version = FALSE;
extern gboolean controller__help;
gboolean controller__help = FALSE;
static gpointer controller_parent_class = NULL;

GType errors_get_type (void) G_GNUC_CONST;
GType controller_get_type (void) G_GNUC_CONST;
GType uri_player_get_type (void) G_GNUC_CONST;
GType win_get_type (void) G_GNUC_CONST;
GType track_list_get_type (void) G_GNUC_CONST;
#define CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTROLLER, ControllerPrivate))
enum  {
	CONTROLLER_DUMMY_PROPERTY
};
void controller_ParseArgs (Controller* self, char*** args, int* args_length1, GError** error);
Controller* controller_new (void);
Controller* controller_construct (GType object_type);
void controller_run (Controller* self);
static gboolean controller_create_and_connect_assets (Controller* self);
static gboolean controller_get_player_duration_info (Controller* self);
static gboolean _controller_get_player_duration_info_gsource_func (gpointer self);
static void controller_print_help (Controller* self, gint error_val);
TrackList* track_list_new (char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous);
TrackList* track_list_construct (GType object_type, char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous);
static void _lambda1_ (TrackList* sender, const char* track, Controller* self);
static void controller_play_track (Controller* self, const char* track);
static void __lambda1__track_list_play_track (TrackList* _sender, const char* track, gpointer self);
static void _lambda2_ (TrackList* sender, Controller* self);
static void controller_quit_running (Controller* self);
static void __lambda2__track_list_quit (TrackList* _sender, gpointer self);
static void _lambda3_ (TrackList* sender, Controller* self);
static void __lambda3__track_list_no_valid_files (TrackList* _sender, gpointer self);
static void _lambda4_ (TrackList* s, const char* str, Controller* self);
void controller_display_info (Controller* self, const char* str);
static void __lambda4__track_list_display_info (TrackList* _sender, const char* str, gpointer self);
UriPlayer* uri_player_new (void);
UriPlayer* uri_player_construct (GType object_type);
void uri_player_set_volume (UriPlayer* self, double vol);
double uri_player_get_volume (UriPlayer* self);
static void _lambda5_ (UriPlayer* player, Controller* self);
static void controller_finished_playing (Controller* self);
static void __lambda5__uri_player_finished_playing (UriPlayer* _sender, gpointer self);
static void _lambda6_ (UriPlayer* player, Controller* self);
static void controller_playing_error (Controller* self);
static void __lambda6__uri_player_playing_error (UriPlayer* _sender, gpointer self);
static void _lambda7_ (UriPlayer* player, gint64 p, gint64 d, Controller* self);
static void controller_process_position_duration (Controller* self, gint64 position, gint64 duration);
static void __lambda7__uri_player_position_duration (UriPlayer* _sender, gint64 position, gint64 duration, gpointer self);
static void _lambda8_ (UriPlayer* player, const char* tag, const char* val, Controller* self);
static void controller_process_tag (Controller* self, const char* tag, const char* val);
static void __lambda8__uri_player_tag_parsed (UriPlayer* _sender, const char* key, const char* val, gpointer self);
static void _lambda9_ (UriPlayer* player, double vol, Controller* self);
static void __lambda9__uri_player_volume_changed (UriPlayer* _sender, double vol, gpointer self);
static void _lambda10_ (UriPlayer* player, const char* stat, Controller* self);
static void __lambda10__uri_player_player_status (UriPlayer* _sender, const char* stat, gpointer self);
static void _lambda11_ (const char* str, Controller* self);
static void __lambda11__uri_player_display_info (UriPlayer* _sender, const char* str, gpointer self);
static void _lambda12_ (const char* str, Controller* self);
void controller_display_file_path (Controller* self, const char* str);
static void __lambda12__uri_player_display_file_path (UriPlayer* _sender, const char* path, gpointer self);
Win* win_new (void);
Win* win_construct (GType object_type);
static void _lambda13_ (Win* obj, gint seconds, Controller* self);
static void controller_seek_forward (Controller* self, gint seconds);
static void __lambda13__win_seek_forward (Win* _sender, gint seconds, gpointer self);
static void _lambda14_ (Win* obj, gint seconds, Controller* self);
static void controller_seek_back (Controller* self, gint seconds);
static void __lambda14__win_seek_back (Win* _sender, gint seconds, gpointer self);
static void _lambda15_ (Win* obj, Controller* self);
static void controller_volume_up (Controller* self);
static void __lambda15__win_change_volume_up (Win* _sender, gpointer self);
static void _lambda16_ (Win* obj, Controller* self);
static void controller_volume_down (Controller* self);
static void __lambda16__win_change_volume_down (Win* _sender, gpointer self);
static void _lambda17_ (Win* obj, Controller* self);
static void controller_pause (Controller* self);
static void __lambda17__win_pause (Win* _sender, gpointer self);
static void _lambda18_ (Win* obj, Controller* self);
static void __lambda18__win_quit (Win* _sender, gpointer self);
static void _lambda19_ (Win* obj, Controller* self);
static void controller_next_track (Controller* self);
static void __lambda19__win_next_track (Win* _sender, gpointer self);
static void _lambda20_ (Win* obj, Controller* self);
static void controller_previous_track (Controller* self);
static void __lambda20__win_previous_track (Win* _sender, gpointer self);
static void _lambda21_ (Win* obj, Controller* self);
gboolean track_list_toggleRandom (TrackList* self);
static void __lambda21__win_toggle_random (Win* _sender, gpointer self);
static void _lambda22_ (Win* obj, Controller* self);
gboolean track_list_toggleContinuous (TrackList* self);
static void __lambda22__win_toggle_continuous (Win* _sender, gpointer self);
gboolean win_run (Win* self);
gboolean track_list_run (TrackList* self);
void uri_player_set_uri (UriPlayer* self, const char* uri);
static void controller_play_audio (Controller* self);
void uri_player_play (UriPlayer* self);
void track_list_get_previous_track (TrackList* self);
void track_list_get_next_track (TrackList* self);
void win_clear_screen (Win* self);
void track_list_playing_error (TrackList* self);
void uri_player_get_duration_info (UriPlayer* self);
void win_set_artist (Win* self, const char* artist);
void win_set_title (Win* self, const char* title);
void win_set_album (Win* self, const char* album);
static char* controller_get_human_time (Controller* self, gint64 ns, gint64 totallen);
static void controller_update_status (Controller* self);
void win_set_status (Win* self, const char* str);
void win_set_played_percent (Win* self, gint per);
void win_quit_ui_thread (Win* self);
void uri_player_seek_forward (UriPlayer* self, gint64 seconds);
void uri_player_seek_back (UriPlayer* self, gint64 seconds);
void uri_player_increase_volume (UriPlayer* self, double val);
void uri_player_decrease_volume (UriPlayer* self, double val);
void uri_player_pause (UriPlayer* self);
void win_display_info (Win* self, const char* str);
void win_set_file_path (Win* self, const char* path);
static void controller_finalize (GObject* obj);
void _vala_main (char** args, int args_length1);
static char** _vala_array_dup1 (char** self, int length);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GOptionEntry CONTROLLER_options[7] = {{"version", 'v', (gint) G_OPTION_FLAG_OPTIONAL_ARG, G_OPTION_ARG_NONE, &controller__version, "print the version number and quit", NULL}, {"volume", 'V', (gint) G_OPTION_FLAG_OPTIONAL_ARG, G_OPTION_ARG_DOUBLE, &controller__volume, "set the initial volume (an integer between 0 and 100)", NULL}, {"list", 'l', (gint) G_OPTION_FLAG_OPTIONAL_ARG, G_OPTION_ARG_NONE, &controller__list, "file is a list", NULL}, {"random", 'r', (gint) G_OPTION_FLAG_OPTIONAL_ARG, G_OPTION_ARG_NONE, &controller__random, "play files randomly ( used with a list )", NULL}, {"continuous", 'c', (gint) G_OPTION_FLAG_OPTIONAL_ARG, G_OPTION_ARG_NONE, &controller__continuous, "play files continuously ( used with a list )", NULL}, {"", 'f', 0, G_OPTION_ARG_STRING_ARRAY, &controller__uri, "file(s) to play", "file(s)"}, {NULL}};


GType errors_get_type (void) {
	static volatile gsize errors_type_id__volatile = 0;
	if (g_once_init_enter (&errors_type_id__volatile)) {
		static const GEnumValue values[] = {{ERRORS_NO_INPUT_FILE, "ERRORS_NO_INPUT_FILE", "no-input-file"}, {ERRORS_FILE_NOT_FOUND, "ERRORS_FILE_NOT_FOUND", "file-not-found"}, {ERRORS_NO_TRACKS_FOUND, "ERRORS_NO_TRACKS_FOUND", "no-tracks-found"}, {0, NULL, NULL}};
		GType errors_type_id;
		errors_type_id = g_enum_register_static ("Errors", values);
		g_once_init_leave (&errors_type_id__volatile, errors_type_id);
	}
	return errors_type_id__volatile;
}


void controller_ParseArgs (Controller* self, char*** args, int* args_length1, GError** error) {
	GOptionContext* _tmp0_;
	GOptionGroup* gstgrp;
	GOptionGroup* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	self->priv->ctx = (_tmp0_ = g_option_context_new (""), _g_option_context_free0 (self->priv->ctx), _tmp0_);
	g_option_context_set_help_enabled (self->priv->ctx, TRUE);
	g_option_context_set_summary (self->priv->ctx, self->priv->summary);
	g_option_context_set_description (self->priv->ctx, self->priv->description);
	g_option_context_add_main_entries (self->priv->ctx, CONTROLLER_options, NULL);
	gstgrp = gst_init_get_option_group ();
	g_option_context_add_group (self->priv->ctx, (_tmp1_ = gstgrp, gstgrp = NULL, _tmp1_));
	g_option_context_set_ignore_unknown_options (self->priv->ctx, FALSE);
	g_option_context_parse (self->priv->ctx, args_length1, args, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_OPTION_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_option_group_free0 (gstgrp);
			return;
		} else {
			_g_option_group_free0 (gstgrp);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_option_group_free0 (gstgrp);
}


Controller* controller_construct (GType object_type) {
	Controller * self = NULL;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	self = (Controller*) g_object_new (object_type, NULL);
	self->priv->version = (_tmp0_ = g_strdup (PACKAGE_VERSION), _g_free0 (self->priv->version), _tmp0_);
	self->priv->summary = (_tmp1_ = g_strdup_printf ("sap %s\nsap is a Simple Audio Player", self->priv->version), _g_free0 (self->priv->summary), _tmp1_);
	self->priv->description = (_tmp2_ = g_strdup ("-examples-\n" \
"sap file1 file2 file3\n" \
"this will play file1,file2 and file3 in order and then quit\n" \
"\n" \
"sap -c file1 file2 file3\n" \
"will play file1,file2 and file3 in order and repeat continuously\n" \
"\n" \
"sap -r file1 file2 file3\n" \
"will play file1,file2 and file3 randomly and continuously\n" \
"\n" \
"sap -l playlist.txt\n" \
"will play files found in a playlist\n" \
"\n" \
"sap -r -l playlist.txt\n" \
"will randomly play files found in a playlist\n" \
"\n" \
"\n" \
"-controls-\n" \
"The following keypresses will control sap as it is playing:\n" \
"Space Bar : pause\n" \
"q : quit\n" \
"Down Arrow : volume down\n" \
"Up Arrow : volume up\n" \
"Left Arrow : seek back\n" \
"Right Arrow : seek forward\n" \
"b : play previous file in list\n" \
"n : play next file in list\n" \
"\n" \
"For VI(M) users, the \"h,j,k,l\" keys behave in a similar fashion\n" \
"to the Arrow keys.If you encounter any bugs, please report them at htt" \
"ps://bugs.launchpad.net/sap+"), _g_free0 (self->priv->description), _tmp2_);
	self->priv->ap_play_time = (_tmp3_ = g_strdup (""), _g_free0 (self->priv->ap_play_time), _tmp3_);
	self->priv->ap_total_time = (_tmp4_ = g_strdup (""), _g_free0 (self->priv->ap_total_time), _tmp4_);
	self->priv->ap_volume = (double) 0;
	self->priv->status_text = (_tmp5_ = g_strdup (""), _g_free0 (self->priv->status_text), _tmp5_);
	return self;
}


Controller* controller_new (void) {
	return controller_construct (TYPE_CONTROLLER);
}


static gboolean _controller_get_player_duration_info_gsource_func (gpointer self) {
	gboolean result;
	result = controller_get_player_duration_info (self);
	return result;
}


void controller_run (Controller* self) {
	GMainLoop* _tmp0_;
	g_return_if_fail (self != NULL);
	if (controller__version) {
		fprintf (stdout, "sap %s\n", self->priv->version);
		return;
	}
	self->priv->loop = (_tmp0_ = g_main_loop_new (NULL, FALSE), _g_main_loop_unref0 (self->priv->loop), _tmp0_);
	if (controller__uri != NULL) {
		if (!controller_create_and_connect_assets (self)) {
			return;
		}
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _controller_get_player_duration_info_gsource_func, g_object_ref (self), g_object_unref);
		g_main_loop_run (self->priv->loop);
	} else {
		controller_print_help (self, (gint) ERRORS_NO_INPUT_FILE);
	}
}


static void _lambda1_ (TrackList* sender, const char* track, Controller* self) {
	g_return_if_fail (sender != NULL);
	g_return_if_fail (track != NULL);
	controller_play_track (self, track);
}


static void __lambda1__track_list_play_track (TrackList* _sender, const char* track, gpointer self) {
	_lambda1_ (_sender, track, self);
}


static void _lambda2_ (TrackList* sender, Controller* self) {
	g_return_if_fail (sender != NULL);
	controller_quit_running (self);
}


static void __lambda2__track_list_quit (TrackList* _sender, gpointer self) {
	_lambda2_ (_sender, self);
}


static void _lambda3_ (TrackList* sender, Controller* self) {
	g_return_if_fail (sender != NULL);
	controller_quit_running (self);
}


static void __lambda3__track_list_no_valid_files (TrackList* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


static void _lambda4_ (TrackList* s, const char* str, Controller* self) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (str != NULL);
	controller_display_info (self, str);
}


static void __lambda4__track_list_display_info (TrackList* _sender, const char* str, gpointer self) {
	_lambda4_ (_sender, str, self);
}


static void _lambda5_ (UriPlayer* player, Controller* self) {
	g_return_if_fail (player != NULL);
	controller_finished_playing (self);
}


static void __lambda5__uri_player_finished_playing (UriPlayer* _sender, gpointer self) {
	_lambda5_ (_sender, self);
}


static void _lambda6_ (UriPlayer* player, Controller* self) {
	g_return_if_fail (player != NULL);
	controller_playing_error (self);
}


static void __lambda6__uri_player_playing_error (UriPlayer* _sender, gpointer self) {
	_lambda6_ (_sender, self);
}


static void _lambda7_ (UriPlayer* player, gint64 p, gint64 d, Controller* self) {
	g_return_if_fail (player != NULL);
	controller_process_position_duration (self, p, d);
}


static void __lambda7__uri_player_position_duration (UriPlayer* _sender, gint64 position, gint64 duration, gpointer self) {
	_lambda7_ (_sender, position, duration, self);
}


static void _lambda8_ (UriPlayer* player, const char* tag, const char* val, Controller* self) {
	g_return_if_fail (player != NULL);
	g_return_if_fail (tag != NULL);
	g_return_if_fail (val != NULL);
	controller_process_tag (self, tag, val);
}


static void __lambda8__uri_player_tag_parsed (UriPlayer* _sender, const char* key, const char* val, gpointer self) {
	_lambda8_ (_sender, key, val, self);
}


static void _lambda9_ (UriPlayer* player, double vol, Controller* self) {
	g_return_if_fail (player != NULL);
	self->priv->ap_volume = vol;
}


static void __lambda9__uri_player_volume_changed (UriPlayer* _sender, double vol, gpointer self) {
	_lambda9_ (_sender, vol, self);
}


static void _lambda10_ (UriPlayer* player, const char* stat, Controller* self) {
	char* _tmp0_;
	g_return_if_fail (player != NULL);
	g_return_if_fail (stat != NULL);
	self->priv->ap_state = (_tmp0_ = g_strdup (stat), _g_free0 (self->priv->ap_state), _tmp0_);
}


static void __lambda10__uri_player_player_status (UriPlayer* _sender, const char* stat, gpointer self) {
	_lambda10_ (_sender, stat, self);
}


static void _lambda11_ (const char* str, Controller* self) {
	g_return_if_fail (str != NULL);
	controller_display_info (self, str);
}


static void __lambda11__uri_player_display_info (UriPlayer* _sender, const char* str, gpointer self) {
	_lambda11_ (str, self);
}


static void _lambda12_ (const char* str, Controller* self) {
	g_return_if_fail (str != NULL);
	controller_display_file_path (self, str);
}


static void __lambda12__uri_player_display_file_path (UriPlayer* _sender, const char* path, gpointer self) {
	_lambda12_ (path, self);
}


static void _lambda13_ (Win* obj, gint seconds, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_seek_forward (self, seconds);
}


static void __lambda13__win_seek_forward (Win* _sender, gint seconds, gpointer self) {
	_lambda13_ (_sender, seconds, self);
}


static void _lambda14_ (Win* obj, gint seconds, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_seek_back (self, seconds);
}


static void __lambda14__win_seek_back (Win* _sender, gint seconds, gpointer self) {
	_lambda14_ (_sender, seconds, self);
}


static void _lambda15_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_volume_up (self);
}


static void __lambda15__win_change_volume_up (Win* _sender, gpointer self) {
	_lambda15_ (_sender, self);
}


static void _lambda16_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_volume_down (self);
}


static void __lambda16__win_change_volume_down (Win* _sender, gpointer self) {
	_lambda16_ (_sender, self);
}


static void _lambda17_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_pause (self);
}


static void __lambda17__win_pause (Win* _sender, gpointer self) {
	_lambda17_ (_sender, self);
}


static void _lambda18_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_quit_running (self);
}


static void __lambda18__win_quit (Win* _sender, gpointer self) {
	_lambda18_ (_sender, self);
}


static void _lambda19_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_next_track (self);
}


static void __lambda19__win_next_track (Win* _sender, gpointer self) {
	_lambda19_ (_sender, self);
}


static void _lambda20_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller_previous_track (self);
}


static void __lambda20__win_previous_track (Win* _sender, gpointer self) {
	_lambda20_ (_sender, self);
}


static void _lambda21_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller__random = track_list_toggleRandom (self->priv->trackList);
}


static void __lambda21__win_toggle_random (Win* _sender, gpointer self) {
	_lambda21_ (_sender, self);
}


static void _lambda22_ (Win* obj, Controller* self) {
	g_return_if_fail (obj != NULL);
	controller__continuous = track_list_toggleContinuous (self->priv->trackList);
}


static void __lambda22__win_toggle_continuous (Win* _sender, gpointer self) {
	_lambda22_ (_sender, self);
}


static gboolean controller_create_and_connect_assets (Controller* self) {
	gboolean result = FALSE;
	TrackList* _tmp0_;
	UriPlayer* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Win* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->trackList = (_tmp0_ = track_list_new (controller__uri, _vala_array_length (controller__uri), controller__list, controller__random, controller__continuous), _g_object_unref0 (self->priv->trackList), _tmp0_);
	g_signal_connect_object (self->priv->trackList, "play-track", (GCallback) __lambda1__track_list_play_track, self, 0);
	g_signal_connect_object (self->priv->trackList, "quit", (GCallback) __lambda2__track_list_quit, self, 0);
	g_signal_connect_object (self->priv->trackList, "no-valid-files", (GCallback) __lambda3__track_list_no_valid_files, self, 0);
	g_signal_connect_object (self->priv->trackList, "display-info", (GCallback) __lambda4__track_list_display_info, self, 0);
	self->priv->myPlayer = (_tmp1_ = uri_player_new (), _g_object_unref0 (self->priv->myPlayer), _tmp1_);
	if (controller__volume < 0) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = controller__volume > 100;
	}
	if (_tmp2_) {
		controller__volume = (double) 70;
	}
	uri_player_set_volume (self->priv->myPlayer, controller__volume * 0.01);
	self->priv->ap_volume = uri_player_get_volume (self->priv->myPlayer);
	g_signal_connect_object (self->priv->myPlayer, "finished-playing", (GCallback) __lambda5__uri_player_finished_playing, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "playing-error", (GCallback) __lambda6__uri_player_playing_error, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "position-duration", (GCallback) __lambda7__uri_player_position_duration, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "tag-parsed", (GCallback) __lambda8__uri_player_tag_parsed, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "volume-changed", (GCallback) __lambda9__uri_player_volume_changed, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "player-status", (GCallback) __lambda10__uri_player_player_status, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "display-info", (GCallback) __lambda11__uri_player_display_info, self, 0);
	g_signal_connect_object (self->priv->myPlayer, "display-file-path", (GCallback) __lambda12__uri_player_display_file_path, self, 0);
	self->priv->myWin = (_tmp3_ = win_new (), _g_object_unref0 (self->priv->myWin), _tmp3_);
	g_signal_connect_object (self->priv->myWin, "seek-forward", (GCallback) __lambda13__win_seek_forward, self, 0);
	g_signal_connect_object (self->priv->myWin, "seek-back", (GCallback) __lambda14__win_seek_back, self, 0);
	g_signal_connect_object (self->priv->myWin, "change-volume-up", (GCallback) __lambda15__win_change_volume_up, self, 0);
	g_signal_connect_object (self->priv->myWin, "change-volume-down", (GCallback) __lambda16__win_change_volume_down, self, 0);
	g_signal_connect_object (self->priv->myWin, "pause", (GCallback) __lambda17__win_pause, self, 0);
	g_signal_connect_object (self->priv->myWin, "quit", (GCallback) __lambda18__win_quit, self, 0);
	g_signal_connect_object (self->priv->myWin, "next-track", (GCallback) __lambda19__win_next_track, self, 0);
	g_signal_connect_object (self->priv->myWin, "previous-track", (GCallback) __lambda20__win_previous_track, self, 0);
	g_signal_connect_object (self->priv->myWin, "toggle-random", (GCallback) __lambda21__win_toggle_random, self, 0);
	g_signal_connect_object (self->priv->myWin, "toggle-continuous", (GCallback) __lambda22__win_toggle_continuous, self, 0);
	if (!win_run (self->priv->myWin)) {
		result = FALSE;
		return result;
	}
	if (!track_list_run (self->priv->trackList)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static void controller_play_track (Controller* self, const char* track) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (track != NULL);
	uri_player_set_uri (self->priv->myPlayer, track);
	controller_play_audio (self);
}


static void controller_play_audio (Controller* self) {
	g_return_if_fail (self != NULL);
	uri_player_play (self->priv->myPlayer);
}


static void controller_previous_track (Controller* self) {
	g_return_if_fail (self != NULL);
	track_list_get_previous_track (self->priv->trackList);
}


static void controller_next_track (Controller* self) {
	g_return_if_fail (self != NULL);
	track_list_get_next_track (self->priv->trackList);
}


static void controller_finished_playing (Controller* self) {
	g_return_if_fail (self != NULL);
	win_clear_screen (self->priv->myWin);
	controller_next_track (self);
}


static void controller_playing_error (Controller* self) {
	g_return_if_fail (self != NULL);
	track_list_playing_error (self->priv->trackList);
}


static gboolean controller_get_player_duration_info (Controller* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	uri_player_get_duration_info (self->priv->myPlayer);
	result = TRUE;
	return result;
}


static void controller_process_tag (Controller* self, const char* tag, const char* val) {
	const char* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tag != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = tag;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("artist"))))
	switch (0) {
		default:
		{
			win_set_artist (self->priv->myWin, val);
			break;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("title"))))
	switch (0) {
		default:
		{
			win_set_title (self->priv->myWin, val);
			break;
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("album"))))
	switch (0) {
		default:
		{
			win_set_album (self->priv->myWin, val);
			break;
		}
	} else
	switch (0) {
		default:
		{
			break;
		}
	}
}


static char* controller_get_human_time (Controller* self, gint64 ns, gint64 totallen) {
	char* result = NULL;
	char* r_val;
	gint64 hours;
	gint64 minutes;
	gint64 sec;
	gint64 totalsec;
	char* _tmp9_;
	char* _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	r_val = g_strdup ("");
	hours = (gint64) 0;
	minutes = (gint64) 0;
	sec = (gint64) 0;
	sec = ns / 1000000000;
	totalsec = totallen / 1000000000;
	if (sec >= 3600) {
		char* _tmp1_;
		char* _tmp2_;
		hours = sec / 3600;
		sec = sec - (hours * 3600);
		if (hours < 10) {
			char* _tmp0_;
			r_val = (_tmp0_ = g_strconcat (r_val, "0", NULL), _g_free0 (r_val), _tmp0_);
		}
		r_val = (_tmp2_ = g_strconcat (r_val, _tmp1_ = g_strdup_printf ("%.0f:", (double) hours), NULL), _g_free0 (r_val), _tmp2_);
		_g_free0 (_tmp1_);
	} else {
		if (totalsec >= 3600) {
			char* _tmp3_;
			r_val = (_tmp3_ = g_strconcat (r_val, "00:", NULL), _g_free0 (r_val), _tmp3_);
		}
	}
	if (sec >= 60) {
		char* _tmp5_;
		char* _tmp6_;
		minutes = sec / 60;
		if (minutes < 10) {
			char* _tmp4_;
			r_val = (_tmp4_ = g_strconcat (r_val, "0", NULL), _g_free0 (r_val), _tmp4_);
		}
		r_val = (_tmp6_ = g_strconcat (r_val, _tmp5_ = g_strdup_printf ("%.0f:", (double) minutes), NULL), _g_free0 (r_val), _tmp6_);
		_g_free0 (_tmp5_);
		sec = sec - (minutes * 60);
	} else {
		if (totalsec >= 60) {
			char* _tmp7_;
			r_val = (_tmp7_ = g_strconcat (r_val, "00:", NULL), _g_free0 (r_val), _tmp7_);
		}
	}
	if (sec < 10) {
		char* _tmp8_;
		r_val = (_tmp8_ = g_strconcat (r_val, "0", NULL), _g_free0 (r_val), _tmp8_);
	}
	r_val = (_tmp10_ = g_strconcat (r_val, _tmp9_ = g_strdup_printf ("%.0f", (double) sec), NULL), _g_free0 (r_val), _tmp10_);
	_g_free0 (_tmp9_);
	result = r_val;
	return result;
}


static void controller_update_status (Controller* self) {
	const char* _tmp0_;
	char* rc;
	const char* _tmp1_;
	char* _tmp2_;
	gint vol;
	char* str;
	g_return_if_fail (self != NULL);
	_tmp0_ = NULL;
	if (controller__random) {
		_tmp0_ = "R";
	} else {
		_tmp0_ = "";
	}
	rc = g_strdup (_tmp0_);
	_tmp1_ = NULL;
	if (controller__continuous) {
		_tmp1_ = "C";
	} else {
		_tmp1_ = "";
	}
	rc = (_tmp2_ = g_strconcat (rc, _tmp1_, NULL), _g_free0 (rc), _tmp2_);
	vol = (gint) (self->priv->ap_volume * 100);
	str = g_strdup_printf ("(%s/%s) %i%% Volume:%i %s %s", self->priv->ap_play_time, self->priv->ap_total_time, self->priv->ap_percent_played, vol, self->priv->ap_state, rc);
	win_set_status (self->priv->myWin, str);
	_g_free0 (str);
	_g_free0 (rc);
}


static void controller_process_position_duration (Controller* self, gint64 position, gint64 duration) {
	float percent = 0.0F;
	g_return_if_fail (self != NULL);
	if (duration < 1) {
	} else {
		char* _tmp0_;
		char* _tmp1_;
		self->priv->ap_play_time = (_tmp0_ = controller_get_human_time (self, position, duration), _g_free0 (self->priv->ap_play_time), _tmp0_);
		self->priv->ap_total_time = (_tmp1_ = controller_get_human_time (self, duration, 0), _g_free0 (self->priv->ap_total_time), _tmp1_);
		percent = (float) ((10000 * position) / duration);
		percent = percent / 100;
		self->priv->ap_percent_played = (gint) percent;
		win_set_played_percent (self->priv->myWin, self->priv->ap_percent_played);
	}
	controller_update_status (self);
}


static void controller_quit_running (Controller* self) {
	g_return_if_fail (self != NULL);
	win_quit_ui_thread (self->priv->myWin);
	if (g_main_loop_is_running (self->priv->loop)) {
		g_main_loop_quit (self->priv->loop);
	}
}


static void controller_print_help (Controller* self, gint error_val) {
	char* help;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
	g_return_if_fail (self != NULL);
	help = g_strdup ("");
	switch (error_val) {
		case ERRORS_NO_INPUT_FILE:
		{
			char* _tmp0_;
			help = (_tmp0_ = g_strdup ("No Input File"), _g_free0 (help), _tmp0_);
			break;
		}
		case ERRORS_FILE_NOT_FOUND:
		{
			char* _tmp1_;
			help = (_tmp1_ = g_strdup ("File Not Found"), _g_free0 (help), _tmp1_);
			break;
		}
		case ERRORS_NO_TRACKS_FOUND:
		{
			char* _tmp2_;
			help = (_tmp2_ = g_strdup ("No Tracks Found"), _g_free0 (help), _tmp2_);
			break;
		}
		default:
		{
			break;
		}
	}
	help = (_tmp5_ = g_strconcat (help, _tmp4_ = g_strconcat ("\n", _tmp3_ = g_option_context_get_help (self->priv->ctx, TRUE, NULL), NULL), NULL), _g_free0 (help), _tmp5_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	fprintf (stdout, "%s", help);
	_g_free0 (help);
}


static void controller_seek_forward (Controller* self, gint seconds) {
	g_return_if_fail (self != NULL);
	uri_player_seek_forward (self->priv->myPlayer, (gint64) seconds);
}


static void controller_seek_back (Controller* self, gint seconds) {
	g_return_if_fail (self != NULL);
	uri_player_seek_back (self->priv->myPlayer, (gint64) seconds);
}


static void controller_volume_up (Controller* self) {
	g_return_if_fail (self != NULL);
	uri_player_increase_volume (self->priv->myPlayer, 0.03);
}


static void controller_volume_down (Controller* self) {
	g_return_if_fail (self != NULL);
	uri_player_decrease_volume (self->priv->myPlayer, 0.03);
}


static void controller_pause (Controller* self) {
	g_return_if_fail (self != NULL);
	uri_player_pause (self->priv->myPlayer);
}


void controller_display_info (Controller* self, const char* str) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	win_display_info (self->priv->myWin, str);
}


void controller_display_file_path (Controller* self, const char* str) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	win_set_file_path (self->priv->myWin, str);
}


static void controller_class_init (ControllerClass * klass) {
	controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ControllerPrivate));
	G_OBJECT_CLASS (klass)->finalize = controller_finalize;
}


static void controller_instance_init (Controller * self) {
	self->priv = CONTROLLER_GET_PRIVATE (self);
}


static void controller_finalize (GObject* obj) {
	Controller * self;
	self = CONTROLLER (obj);
	_g_object_unref0 (self->priv->myPlayer);
	_g_object_unref0 (self->priv->myWin);
	_g_object_unref0 (self->priv->trackList);
	_g_free0 (self->priv->version);
	_g_free0 (self->priv->summary);
	_g_free0 (self->priv->description);
	_g_free0 (self->priv->status_text);
	_g_main_loop_unref0 (self->priv->loop);
	_g_option_context_free0 (self->priv->ctx);
	_g_free0 (self->priv->ap_play_time);
	_g_free0 (self->priv->ap_total_time);
	_g_free0 (self->priv->ap_state);
	G_OBJECT_CLASS (controller_parent_class)->finalize (obj);
}


GType controller_get_type (void) {
	static volatile gsize controller_type_id__volatile = 0;
	if (g_once_init_enter (&controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Controller), 0, (GInstanceInitFunc) controller_instance_init, NULL };
		GType controller_type_id;
		controller_type_id = g_type_register_static (G_TYPE_OBJECT, "Controller", &g_define_type_info, 0);
		g_once_init_leave (&controller_type_id__volatile, controller_type_id);
	}
	return controller_type_id__volatile;
}


static char** _vala_array_dup1 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


void _vala_main (char** args, int args_length1) {
	gint input_length1;
	gint _input_size_;
	char** _tmp1_;
	char** _tmp0_;
	char** input;
	Controller* myController;
	GError * _inner_error_ = NULL;
	input = (_tmp1_ = (_tmp0_ = args, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup1 (_tmp0_, args_length1)), input_length1 = args_length1, _input_size_ = input_length1, _tmp1_);
	if (!g_thread_supported ()) {
		fprintf (stderr, "Cannot run without threads.\n");
		input = (_vala_array_free (input, input_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	myController = controller_new ();
	{
		controller_ParseArgs (myController, &input, &input_length1, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch1_g_option_error;
			}
			_g_object_unref0 (myController);
			input = (_vala_array_free (input, input_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally1;
	__catch1_g_option_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stdout, "%s\n", err->message);
			_g_error_free0 (err);
			_g_object_unref0 (myController);
			input = (_vala_array_free (input, input_length1, (GDestroyNotify) g_free), NULL);
			return;
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (myController);
		input = (_vala_array_free (input, input_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gst_init (&args_length1, &args);
	controller_run (myController);
	_g_object_unref0 (myController);
	input = (_vala_array_free (input, input_length1, (GDestroyNotify) g_free), NULL);
}


int main (int argc, char ** argv) {
	g_type_init ();
	_vala_main (argv, argc);
	return 0;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




