/* tracklist.c generated by valac 0.10.1, the Vala compiler
 * generated from tracklist.vala, do not modify */

/*

this is a part of sap
copyright 2008 jezra lickter http://www.jezra.net

sap is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

sap is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sap.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>


#define TYPE_TRACK_LIST (track_list_get_type ())
#define TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRACK_LIST, TrackList))
#define TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRACK_LIST, TrackListClass))
#define IS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRACK_LIST))
#define IS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRACK_LIST))
#define TRACK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRACK_LIST, TrackListClass))

typedef struct _TrackList TrackList;
typedef struct _TrackListClass TrackListClass;
typedef struct _TrackListPrivate TrackListPrivate;
#define _g_array_free0(var) ((var == NULL) ? NULL : (var = (g_array_free (var, TRUE), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TrackList {
	GObject parent_instance;
	TrackListPrivate * priv;
};

struct _TrackListClass {
	GObjectClass parent_class;
};

struct _TrackListPrivate {
	GArray* played_indexes;
	GArray* available_indexes;
	GArray* bad_indexes;
	guint current_track_index;
	gboolean islist;
	char** uris;
	gint uris_length1;
	gint _uris_size_;
	gboolean first_track_found;
	GHashTable* track_table;
	gboolean random;
	gboolean continuous;
};


static gpointer track_list_parent_class = NULL;

GType track_list_get_type (void) G_GNUC_CONST;
#define TRACK_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TRACK_LIST, TrackListPrivate))
enum  {
	TRACK_LIST_DUMMY_PROPERTY
};
TrackList* track_list_new (char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous);
TrackList* track_list_construct (GType object_type, char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous);
static char** _vala_array_dup2 (char** self, int length);
gboolean track_list_run (TrackList* self);
void* track_list_file_thread (TrackList* self);
static void* _track_list_file_thread_gthread_func (gpointer self);
static void track_list_process_file_uri_list (TrackList* self, const char* uri_list);
static void track_list_process_file_uri (TrackList* self, const char* file_uri_path);
gboolean track_list_toggleRandom (TrackList* self);
gboolean track_list_toggleContinuous (TrackList* self);
void track_list_playing_error (TrackList* self);
void track_list_get_next_track (TrackList* self);
gboolean track_list_get_random (TrackList* self);
void track_list_get_previous_track (TrackList* self);
guint track_list_get_track_count (TrackList* self);
static void track_list_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



static char** _vala_array_dup2 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


TrackList* track_list_construct (GType object_type, char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous) {
	TrackList * self = NULL;
	char** _tmp0_;
	char** _tmp1_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	GHashTable* _tmp5_;
	self = (TrackList*) g_object_new (object_type, NULL);
	self->priv->random = random;
	self->priv->continuous = continuous;
	self->priv->uris = (_tmp1_ = (_tmp0_ = uris, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup2 (_tmp0_, uris_length1)), self->priv->uris = (_vala_array_free (self->priv->uris, self->priv->uris_length1, (GDestroyNotify) g_free), NULL), self->priv->uris_length1 = uris_length1, self->priv->_uris_size_ = self->priv->uris_length1, _tmp1_);
	self->priv->islist = islist;
	self->priv->first_track_found = FALSE;
	self->priv->available_indexes = (_tmp2_ = g_array_new (FALSE, FALSE, (gulong) ((guint) sizeof (gint))), _g_array_free0 (self->priv->available_indexes), _tmp2_);
	self->priv->played_indexes = (_tmp3_ = g_array_new (FALSE, FALSE, (gulong) ((guint) sizeof (gint))), _g_array_free0 (self->priv->played_indexes), _tmp3_);
	self->priv->bad_indexes = (_tmp4_ = g_array_new (FALSE, FALSE, (gulong) ((guint) sizeof (gint))), _g_array_free0 (self->priv->bad_indexes), _tmp4_);
	self->priv->track_table = (_tmp5_ = g_hash_table_new_full (NULL, NULL, NULL, g_free), _g_hash_table_unref0 (self->priv->track_table), _tmp5_);
	self->priv->current_track_index = (guint) (-1);
	return self;
}


TrackList* track_list_new (char** uris, int uris_length1, gboolean islist, gboolean random, gboolean continuous) {
	return track_list_construct (TYPE_TRACK_LIST, uris, uris_length1, islist, random, continuous);
}


static void* _track_list_file_thread_gthread_func (gpointer self) {
	void* result;
	result = track_list_file_thread (self);
	return result;
}


gboolean track_list_run (TrackList* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		g_thread_create (_track_list_file_thread_gthread_func, self, FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch2_g_thread_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = TRUE;
		return result;
	}
	goto __finally2;
	__catch2_g_thread_error:
	{
		GError * ex;
		ex = _inner_error_;
		_inner_error_ = NULL;
		{
			fprintf (stderr, "Failed to create the file parsing thread");
			result = FALSE;
			_g_error_free0 (ex);
			return result;
		}
	}
	__finally2:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


void* track_list_file_thread (TrackList* self) {
	void* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		char** uri_collection;
		int uri_collection_length1;
		int uri_it;
		uri_collection = self->priv->uris;
		uri_collection_length1 = self->priv->uris_length1;
		for (uri_it = 0; uri_it < self->priv->uris_length1; uri_it = uri_it + 1) {
			char* uri;
			uri = g_strdup (uri_collection[uri_it]);
			{
				if (self->priv->islist) {
					track_list_process_file_uri_list (self, uri);
				} else {
					track_list_process_file_uri (self, uri);
				}
				_g_free0 (uri);
			}
		}
	}
	if (g_hash_table_size (self->priv->track_table) == 0) {
		g_signal_emit_by_name (self, "no-valid-files");
	}
	g_signal_emit_by_name (self, "processing-finished");
	result = NULL;
	return result;
}


gboolean track_list_toggleRandom (TrackList* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->random) {
		_tmp0_ = FALSE;
	} else {
		_tmp0_ = TRUE;
	}
	self->priv->random = _tmp0_;
	result = self->priv->random;
	return result;
}


gboolean track_list_toggleContinuous (TrackList* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->continuous) {
		_tmp0_ = FALSE;
	} else {
		_tmp0_ = TRUE;
	}
	self->priv->continuous = _tmp0_;
	result = self->priv->continuous;
	return result;
}


void track_list_playing_error (TrackList* self) {
	g_return_if_fail (self != NULL);
	track_list_get_next_track (self);
}


gboolean track_list_get_random (TrackList* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->random;
	return result;
}


static void track_list_process_file_uri_list (TrackList* self, const char* uri_list) {
	char* file_contents;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (uri_list != NULL);
	file_contents = g_strdup ("");
	if (g_file_test (uri_list, G_FILE_TEST_EXISTS)) {
		gint file_uris_length1;
		gint _file_uris_size_;
		char** _tmp3_;
		char** _tmp2_;
		char** file_uris;
		{
			char* _tmp0_ = NULL;
			char* _tmp1_;
			g_file_get_contents (uri_list, &_tmp0_, NULL, &_inner_error_);
			file_contents = (_tmp1_ = _tmp0_, _g_free0 (file_contents), _tmp1_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch3_g_file_error;
				}
				_g_free0 (file_contents);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally3;
		__catch3_g_file_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				_g_error_free0 (err);
				_g_free0 (file_contents);
				return;
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_free0 (file_contents);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		file_uris = (_tmp3_ = _tmp2_ = g_strsplit (file_contents, "\n", 0), file_uris_length1 = _vala_array_length (_tmp2_), _file_uris_size_ = file_uris_length1, _tmp3_);
		{
			char** uri_collection;
			int uri_collection_length1;
			int uri_it;
			uri_collection = file_uris;
			uri_collection_length1 = file_uris_length1;
			for (uri_it = 0; uri_it < file_uris_length1; uri_it = uri_it + 1) {
				char* uri;
				uri = g_strdup (uri_collection[uri_it]);
				{
					track_list_process_file_uri (self, uri);
					_g_free0 (uri);
				}
			}
		}
		file_uris = (_vala_array_free (file_uris, file_uris_length1, (GDestroyNotify) g_free), NULL);
	} else {
	}
	_g_free0 (file_contents);
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
	return result;
}


static void track_list_process_file_uri (TrackList* self, const char* file_uri_path) {
	char* file_uri;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_uri_path != NULL);
	if (string_get_length (file_uri_path) == 0) {
		return;
	}
	file_uri = NULL;
	if (g_file_test (file_uri_path, G_FILE_TEST_EXISTS)) {
		if (g_path_is_absolute (file_uri_path)) {
			char* _tmp0_;
			file_uri = (_tmp0_ = g_strconcat ("file://", file_uri_path, NULL), _g_free0 (file_uri), _tmp0_);
		} else {
			char* _tmp1_;
			char* _tmp2_;
			char* _tmp3_;
			file_uri = (_tmp3_ = g_strconcat ("file://", _tmp2_ = g_build_filename (_tmp1_ = g_get_current_dir (), file_uri_path, NULL), NULL), _g_free0 (file_uri), _tmp3_);
			_g_free0 (_tmp2_);
			_g_free0 (_tmp1_);
		}
	} else {
		char* _tmp4_;
		gboolean _tmp5_;
		if ((_tmp5_ = g_str_has_prefix (_tmp4_ = g_utf8_strdown (file_uri_path, -1), "http://"), _g_free0 (_tmp4_), _tmp5_)) {
			char* _tmp6_;
			file_uri = (_tmp6_ = g_strdup (file_uri_path), _g_free0 (file_uri), _tmp6_);
		} else {
		}
	}
	if (file_uri != NULL) {
		guint val;
		g_hash_table_insert (self->priv->track_table, GUINT_TO_POINTER (g_hash_table_size (self->priv->track_table)), g_strdup (file_uri));
		val = g_hash_table_size (self->priv->track_table) - 1;
		g_array_append_val (self->priv->available_indexes, val);
		if (!self->priv->first_track_found) {
			self->priv->first_track_found = TRUE;
			track_list_get_next_track (self);
		}
	}
	_g_free0 (file_uri);
}


void track_list_get_next_track (TrackList* self) {
	guint track_index = 0U;
	guint rand_index = 0U;
	char* _tmp1_;
	char* track;
	g_return_if_fail (self != NULL);
	if (self->priv->random) {
		if (self->priv->current_track_index >= (-1)) {
			g_array_append_val (self->priv->played_indexes, self->priv->current_track_index);
		}
		rand_index = (guint) g_random_int_range ((gint32) 0, (gint32) self->priv->available_indexes->len);
		track_index = (guint) ((gint) g_array_index (self->priv->available_indexes, guint, rand_index));
		g_array_remove_index_fast (self->priv->available_indexes, rand_index);
		if (self->priv->available_indexes->len == 0) {
			{
				guint i;
				i = (guint) 0;
				{
					gboolean _tmp0_;
					_tmp0_ = TRUE;
					while (TRUE) {
						if (!_tmp0_) {
							i++;
						}
						_tmp0_ = FALSE;
						if (!(i < g_hash_table_size (self->priv->track_table))) {
							break;
						}
						g_array_append_val (self->priv->available_indexes, i);
					}
				}
			}
		}
	} else {
		track_index = self->priv->current_track_index + 1;
		if (track_index > (g_hash_table_size (self->priv->track_table) - 1)) {
			if (self->priv->continuous) {
				track_index = (guint) 0;
			} else {
				g_signal_emit_by_name (self, "quit");
				return;
			}
		}
	}
	g_signal_emit_by_name (self, "display-info", _tmp1_ = g_strdup_printf ("current index: %0.f track_index: %0f", (double) self->priv->current_track_index, (double) track_index));
	_g_free0 (_tmp1_);
	self->priv->current_track_index = track_index;
	track = g_strdup ((const char*) g_hash_table_lookup (self->priv->track_table, GUINT_TO_POINTER (track_index)));
	g_signal_emit_by_name (self, "play-track", track);
	_g_free0 (track);
}


void track_list_get_previous_track (TrackList* self) {
	guint previous_index;
	guint played_indexes_length = 0U;
	char* track;
	char* info;
	char* _tmp5_;
	char* _tmp6_;
	g_return_if_fail (self != NULL);
	previous_index = (guint) 0;
	track = g_strdup ("");
	info = g_strdup ("");
	played_indexes_length = self->priv->played_indexes->len;
	if (played_indexes_length > 0) {
		previous_index = g_array_index (self->priv->played_indexes, guint, played_indexes_length - 1);
		g_array_remove_index (self->priv->played_indexes, played_indexes_length - 1);
	} else {
		if (self->priv->random) {
			track_list_get_next_track (self);
			_g_free0 (info);
			_g_free0 (track);
			return;
		} else {
			char* _tmp0_;
			info = (_tmp0_ = g_strconcat (info, "not random ", NULL), _g_free0 (info), _tmp0_);
			if (self->priv->current_track_index > 0) {
				char* _tmp1_;
				char* _tmp2_;
				previous_index = self->priv->current_track_index - 1;
				info = (_tmp2_ = g_strconcat (info, _tmp1_ = g_strdup_printf ("currentindex:%.0f, previous_index:%.0f ", (double) self->priv->current_track_index, (double) previous_index), NULL), _g_free0 (info), _tmp2_);
				_g_free0 (_tmp1_);
			} else {
				if (self->priv->continuous) {
					char* _tmp3_;
					previous_index = g_hash_table_size (self->priv->track_table) - 1;
					info = (_tmp3_ = g_strconcat (info, "is continuous ", NULL), _g_free0 (info), _tmp3_);
				} else {
					char* _tmp4_;
					previous_index = (guint) 0;
					info = (_tmp4_ = g_strconcat (info, "not continuous ", NULL), _g_free0 (info), _tmp4_);
				}
			}
		}
	}
	track = (_tmp5_ = g_strdup ((const char*) g_hash_table_lookup (self->priv->track_table, GUINT_TO_POINTER (previous_index))), _g_free0 (track), _tmp5_);
	self->priv->current_track_index = previous_index;
	g_signal_emit_by_name (self, "display-info", _tmp6_ = g_strdup_printf ("previous_index:%.0f, current index:%.0f , %s", (double) previous_index, (double) self->priv->current_track_index, info));
	_g_free0 (_tmp6_);
	if (_vala_strcmp0 (track, "") != 0) {
		g_signal_emit_by_name (self, "play-track", track);
	} else {
	}
	_g_free0 (info);
	_g_free0 (track);
}


guint track_list_get_track_count (TrackList* self) {
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_hash_table_size (self->priv->track_table);
	return result;
}


static void track_list_class_init (TrackListClass * klass) {
	track_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TrackListPrivate));
	G_OBJECT_CLASS (klass)->finalize = track_list_finalize;
	g_signal_new ("quit", TYPE_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("processing_finished", TYPE_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("no_valid_files", TYPE_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("play_track", TYPE_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("display_info", TYPE_TRACK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void track_list_instance_init (TrackList * self) {
	self->priv = TRACK_LIST_GET_PRIVATE (self);
}


static void track_list_finalize (GObject* obj) {
	TrackList * self;
	self = TRACK_LIST (obj);
	_g_array_free0 (self->priv->played_indexes);
	_g_array_free0 (self->priv->available_indexes);
	_g_array_free0 (self->priv->bad_indexes);
	self->priv->uris = (_vala_array_free (self->priv->uris, self->priv->uris_length1, (GDestroyNotify) g_free), NULL);
	_g_hash_table_unref0 (self->priv->track_table);
	G_OBJECT_CLASS (track_list_parent_class)->finalize (obj);
}


GType track_list_get_type (void) {
	static volatile gsize track_list_type_id__volatile = 0;
	if (g_once_init_enter (&track_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TrackListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) track_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrackList), 0, (GInstanceInitFunc) track_list_instance_init, NULL };
		GType track_list_type_id;
		track_list_type_id = g_type_register_static (G_TYPE_OBJECT, "TrackList", &g_define_type_info, 0);
		g_once_init_leave (&track_list_type_id__volatile, track_list_type_id);
	}
	return track_list_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




